/**
 * Copyright 2017 Confluent Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


#include "monitoring_pb_extension.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>


bool static write_string(pb_ostream_t *stream, const pb_field_t *field, void * const *arg){

    if(*arg == NULL)
        return true;

    if(!pb_encode_tag_for_field(stream, field))
        return false;

    if(!pb_encode_string(stream, *arg, strlen(*arg)))
        return false;

    return true;
}


void string_encode_callback(pb_callback_t* pb_callback, char* arg){
    pb_callback->funcs.encode = &write_string;
    pb_callback->arg = (void*)arg;
}

void  monitoring_message_init(monitoring_MonitoringMessage *message){
    static monitoring_MonitoringMessage init_value = monitoring_MonitoringMessage_init_default;
    *message = init_value;
    message->minLatency = INT_MAX;
}

