/**
 * Copyright 2017 Confluent Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */


/**
 * @brief Topic+Partition map
 *
 * Data value is currently hard-code to timebuckets_t
 */

#include "timebucket.h"

typedef struct tp_s {
        TAILQ_ENTRY(tp_s) link;
        TAILQ_ENTRY(tp_s) flat_link;
        int32_t partition;
        char   *topic;

        timebuckets_t tbs;
} tp_t;

typedef struct tpmap_s {
        TAILQ_HEAD(, tp_s)  *tpm_elems;  /* element list array */
        TAILQ_HEAD(, tp_s)   tpm_flat;   /* flat link */
        int tpm_size;
} tpmap_t;


tp_t *tp_get (tpmap_t *tpm, const char *topic, int32_t partition,
              int win_size);

void tpmap_destroy (tpmap_t *tpm);
void tpmap_init (tpmap_t *tpm, int size);

